<template>
  <div id="app">
    <Spinner v-if="!page_ready"></Spinner>
    <div>
      <b-navbar type="dark" variant="dark">
        <b-collapse id="nav-collapse" is-nav>
          <b-navbar-nav class="ml-auto">
            <b-nav-item-dropdown right v-if="meta.user.permissions.can_use_administration_tools">
              <template #button-content>
                <em>administration</em>
              </template>

            </b-nav-item-dropdown>
            <b-nav-item-dropdown right>
              <template #button-content>
                <em>{{ meta.user.uid ? meta.user.uid : 'user' }}</em>
              </template>
              <b-dropdown-item v-if="meta.user.uid" @click="logout" href="#">Logout</b-dropdown-item>

            </b-nav-item-dropdown>
          </b-navbar-nav>
        </b-collapse>
      </b-navbar>

      <div style="padding-top: 30px;">
        <b-container v-if="!meta.user.uid" class="auth">
          <authorization
              @template_ready="template_ready"
              @template_load="template_load"
          ></authorization>
        </b-container>
        <AdminPanel v-else>

        </AdminPanel>


      </div>

    </div>
  </div>
</template>


<script>

import router from "@/router";
import Spinner from "@/views/Spinner";
import Authorization from "@/views/Authorization";
import AdminPanel from "@/views/AdminPanel";

export default {
  name: "Map",
  components: {
    Spinner,
    Authorization,
    AdminPanel
  },

  data: function () {
    return {
      uid: undefined,
      page_ready: false,
      meta: router.options.meta,
      window: window,
    };
  },
  mounted: function () {
    if (!this.meta.user.uid) {
      this.template_ready()
    }

  },

  methods: {
    template_ready: function () {
      console.log('app ready ')
      this.page_ready = true;

    },
    template_load: function () {
      console.log('template load...')
      this.page_ready = false;
    },
    logout: function () {
      router.options.logout()
    }
  }
}
</script>


<style>
#app {
  font-family: Avenir, Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: center;
  color: #2c3e50;
}

#app {
  padding-left: 0;
  padding-right: 0;
}

.auth {
  margin-top: 30px;
  max-width: 450px !important;

}

</style>
